function [R, R_Err, Err, time, fend, iter, F, T] = SU_linesearch(A, Q, k, x0)
   
    params.x0 = x0;
    params.k_max = k;   
    params.linesearch = 1;
    params.min_Delta = eps;
    params.debug = 0;
    params.max_t = 2000;
    params.restart = 0;
    params.StopCriterion = 0;
    params.error = 1e-08;
    params.manifold = 2;
    params.m = 4;
    params.alpha = 0.01;
    params.beta = 0.99;
    params.Delta_bar = inf;
    params.Delta0 = 1;
    
    params.minstepsize = 1e-8;
    params.maxstepsize = 200;
    
    params.tol = 1e-6;   % Sugg: 1e-6  % 11PA
    params.vector_transport = 1;

    
    [m, n] = size(A);
    s = x0.u * x0.d * x0.v';
    QX = Q * reshape(A - s, [], 1);
    grad = reshape(-2 * QX, m, n);
    Initialgradfull = sqrt(sum(sum(grad.*grad)));
    params.Gfull0 = Initialgradfull;
    fprintf('Norm of initial full gradient: %e\n', Initialgradfull);
    
    fns = {};
    [X, F, G, time, nf, ng, T, nR] = driver_SU_linesearch(A, Q, fns,params);
    
    iter = size(X, 2);
    for i = 1 : iter
        x = X{i};
        Riter{i} = x.u * x.d * x.v';
        Av = reshape(A,[],1);
        err(i) = sqrt(F(i) / (Av' * Q * Av));
    end  
    R = Riter{end};    
    
    fend = F(end);
    R_Err = sqrt(fend / (A(:)' * Q * A(:)));
    Err = norm(A - R, 'fro');
    
    gff = G(end) / Initialgradfull;
    
   
end

