function [R, timecost, R_Err, Err, fend, F, T] = test_manton_weighted(A, Q, k, meth, vt)

%     fprintf('which algorithm do you want to test: \n');
%     fprintf('1, RBroydenFamily(phi could be modified in stiefel.m) \n');
%     fprintf('2, RBFGS \n');
%     fprintf('3, LRBFGS \n');
%     fprintf('4, RSD \n');
%     fprintf('5, RTR-SR1 \n');
%     fprintf('6, LRTR-SR1 \n');
%     fprintf('7, RTR-SD \n');
%     fprintf('8, RGS \n');
%     fprintf('9, RTR-Newton \n');
%     fprintf('10, RCG \n');
%     fprintf('11, RNewton \n');
%     fprintf('12, check grad Hess \n');
%     fprintf('otherwise, break \n');
    method = meth; %input('please input: ');
    if(method < 1 || method > 12)
        fprintf('exit! \n');
        return;
    end
%     fprintf('which retraction do you want to test: \n');
%     fprintf('1, parallel \n');
%     fprintf('2, qf \n');
%     fprintf('3, constructed Retraction \n');
%     fprintf('otherwise, break \n');
    Retraction = 2; %input('please input: ');
    if(Retraction < 1 || Retraction > 3)
        fprintf('exit! \n');
        return;
    end
%     fprintf('which vector transport do you want to test: \n');
%     fprintf('1, nonIso: vector transport by projection \n')
%     fprintf('2, Iso: parallel transport \n')
%     fprintf('3, Iso: direct-rotation with basis on tangent space \n')
%     fprintf('4, Iso: direct-rotation with basis on normal space \n')
%     fprintf('5, Iso: smooth basis on tangent space \n')
%     fprintf('6, Iso: smooth basis on normal space \n')
%     fprintf('7, Iso: intrinsic approach \n')
%     fprintf('8, Locking-Iso(qf): direct-rotation with basis on tangent space \n')
%     fprintf('9, Locking-Iso(qf): direct-rotation with basis on normal space \n')
%     fprintf('10, Locking-Iso(qf): smooth basis on tangent space \n')
%     fprintf('11,Locking-Iso(qf): smooth basis on normal space \n')
%     fprintf('12,Locking-Iso(qf): construct vector transport \n')
%     fprintf('13,Locking-Iso(qf): intrinsic approach \n')
%     fprintf('otherwise, break \n');
    VT = vt; %input('please input: ');
    if(VT < 1 || VT > 13)
        fprintf('exit! \n');
        return;
    end
%% ---------1  2  3  4  5  6  7  8  9 10 11 12 13
    LC_M = [0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0;
            0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1;
            0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0;];
    if((method <= 3 || method == 10) && ~LC_M(Retraction, VT))
        fprintf('Locking condition is not satisfied. Algorithm may fail. \n')
        fprintf('Do you still want to run it? \n')
        fprintf('1: run \n')
        fprintf('otherwise: exit \n')
        flag = input('input: ');
        if(isempty(flag) || flag ~= 1)
            fprintf('exit! \n');
            return;
        end
    end
    
    [m, n] = size(A);
    x = randn(n, n-k);
    [x1.U, ~] = qr(x, 0);
    if(VT == 7 || VT == 13 || VT == 14)
        if(method == 1 || method == 2 || method == 5)
            d = (n - k) * k;
            H0 = eye(d);
            B0 = eye(d);
            params.H0 = H0;
            params.B0 = B0;
        end
        x0 = x1;
        clear('x1');
        x1.U = x0.U;
        x1.Up = null(x0.U');
    else
        if(method == 1 || method == 2 || method == 5)
            H0 = eye(n * (n - k));
            B0 = eye(n * (n - k));
            params.H0 = H0;
            params.B0 = B0;
        end
    end
    
    params.x0 = x1;
    params.error = 1e-6;  % 11PA Sugg: 1e-6
    params.StopCriterion = 3;
    params.max_t = 2000;
    params.debug = 0;
    params.manifold = 4;
    params.m = 5;
    params.linesearch = 1;
    params.alpha = 0.01; %1e-4;
    params.beta = 0.99; %0.999;
    params.Delta_bar = inf;
    params.Delta0 = 1;
    params.min_Delta = eps;
    params.minstepsize = eps;
    params.maxstepsize = 200;
    params.retraction = Retraction;
    params.vector_transport = VT;
    fns = {};

%     tic
%     Q_inv = inv(Q);
%     timecost = toc;
%     [X, F, G, time] = driver_manton_lowrank_Qinv(A, Q_inv, fns, params, method);
%     timecost = timecost + time;
 
    tic
    L = chol(Q);
    timecost_chol = toc;   
        [X, F, G, time, T] = driver_manton_lowrank_L(A, L, fns, params, method);
    timecost = timecost_chol + time;

    tic
    x = X{end};
    if(~isfield(x, 'hAX'))
        if(~isfield(x, 'h'))
            if(~isfield(x,'QN'))
                if(~isfield(x, 'NI'))
                    x.NI = kron(x.U, eye(m));
                end
                x.QN = L \ (L' \ x.NI);
            end
            x.h = x.NI' * x.QN;
        end
        if(~isfield(x,'AX'))
            x.AX = reshape(A * x.U, [], 1);
        end
        x.hAX = x.h \ x.AX;
    end
    vector_R = A(:) - x.QN * x.hAX;
        
%     p = size(x.U, 2);
%     QN = zeros(m*p, m*n);
%     for i = 1 : (m*n)
%         q = reshape(Q_inv(:,i), m, n);
%         QN(:,i) = reshape(q * x.U, [], 1);
%     end
%     
%     % h = kron(N, I)^T Q^{-1} kron(N,I)
%     h = zeros(m*p, m*p);
%     for i = 1 : (m*p)
%         q = reshape(QN(i, :), m, n);
%         h(i, :) = reshape(q * x.U, [], 1);
%     end
%     
%     AN = reshape(A * x.U, [], 1);
%     hAN = h \ AN;
%     temp_a = kron(x.U, eye(m));
%     temp_b = Q \ temp_a;
%     vector_R = A(:) - temp_b * hAN;
    R = reshape(vector_R, m, n);
    time_computeR = toc;
    
    
    
    timecost = timecost + time_computeR;
    
    temp = reshape(A - R, [], 1);
    fend = temp' * Q * temp; 
    R_Err = sqrt(fend / (A(:)' * Q * A(:)));
    
    Err = norm(A - R, 'fro');
    
    for j = 1 : length(F)
        x = X{j};
        p = size(x.U, 2);
    
        if(~isfield(x, 'hAX'))
            if(~isfield(x, 'h'))
                if(~isfield(x,'QN'))
                    if(~isfield(x, 'NI'))
                        x.NI = kron(x.U, eye(m));
                    end
                    x.QN = L \ (L' \ x.NI);
                end
                x.h = x.NI' * x.QN;
            end
            if(~isfield(x,'AX'))
                x.AX = reshape(A * x.U, [], 1);
            end
            x.hAX = x.h \ x.AX;
        end
        vector_R = A(:) - x.QN * x.hAX;
        R_x{j} = reshape(vector_R, m, n);
        temp = reshape(A - R_x{j}, [], 1);
        f_original(j) = temp' * Q * temp; 
        err(j) = f_original(j) / (A(:)' * Q * A(:));
    end
    

end
