function [R, Err, R_Err, time, fend, Gend, F, T] = test_wlr(A, Q, k, x0, retract, meth, vt)

[m, n] = size(A);

%     fprintf('which algorithm do you want to test: \n');
%     fprintf('1, RTR_SD \n');
%     fprintf('2, RTR_SR1 \n');
%     fprintf('3, LRTR_SR1 \n');
%     fprintf('4, RTR_Newton \n');
%     fprintf('5, RBFGS \n');
%     fprintf('6, LRBFGS \n');
%     fprintf('7, RSD \n');
%     fprintf('8, RCG \n');
%     fprintf('9, RNewton \n');

%     fprintf('otherwise, break \n');
    method = meth; %input('please input: ');
    if(method < 1 || method > 9)
        fprintf('exit! \n');
        return;
    end
%     
%     fprintf('which retraction do you want to test: \n');
%     fprintf('1, svd \n');
%     fprintf('2, polar decomposition \n');
%     fprintf('3, qf1 \n');
%     fprintf('4, qf2 \n');
%     fprintf('otherwise, break \n');
    retraction = retract; %input('please input: ');
    if(retraction < 1 || retraction > 4)
        fprintf('exit! \n');
        return;
    end

%     
%     fprintf('which vector transport do you want to test: \n');
%     fprintf('1, direct-rotation with smooth basis on tangent space with SVD  \n');
%     fprintf('2, direct-rotation with smooth basis on normal space with SVD \n');
%     fprintf('3, smooth basis on tangent space without SVD \n');
%     fprintf('4, smooth basis on normal space without SVD \n');
%     fprintf('5, intrinsic method \n');
%     fprintf('6, Locking(qf) : direct-rotation with smooth basis on tangent space with SVD \n');
%     fprintf('7, Locking(qf) : direct-rotation with smooth basis on normal space with SVD \n');
%     fprintf('8, Locking(qf) : smooth basis on tangent space without SVD \n');
%     fprintf('9, Locking(qf) : smooth basis on normal space without SVD \n');
%     fprintf('10, Locking(qf) : construct vector transport \n');
%     fprintf('11, Locking(qf) : Intrinsic method \n');    
%     fprintf('otherwise, break \n');
    vector_transport = vt; %input('please input: ');
    if(vector_transport < 1 || vector_transport > 11)
        fprintf('exit! \n');
        return;
    end
    if(method == 2 || method == 5 || method == 6)
        if vector_transport == 5 || vector_transport == 11
            l = length(x0.d);
            d = (m + n - l) * l;
            H0 = eye(d);
            B0 = eye(d);
            x0.uperp = null(x0.u');
            x0.vperp = null(x0.v');
        else
            H0 = eye(m * n);
            B0 = eye(m * n);
        end
        params.H0 = H0;
        params.B0 = B0;
    end
    

    params.retraction = retraction;
    params.vector_transport = vector_transport;
    params.method = method;
    x0.r = length(x0.d);
    x0.l = length(x0.d);
    x0.delta = 1e-07; % parameter delta in Algorithm 1 (determine numerical rank)
    params.x0 = x0;
    
    
    params.linesearch = 1;   % 11PA - like in SU_linesearch.m
    params.min_Delta = eps;
    params.debug = 0;
    params.max_t = 2000;
    params.restart = 0;
    params.StopCriterion = 0;
%     params.error = 1e-08;
    params.m = 4;
    params.alpha = 0.01;
    params.beta = 0.99;
    params.Delta_bar = inf;
    params.Delta0 = 1; 
    params.minstepsize = 1e-8;
    params.maxstepsize = 200;
    
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  	params.k_max = k; % maximum k 
    params.delta = 1e-2; % Initial numerical rank threshold  % 11PA old: 1e-7  
    params.total_steps = 1000; % maximum iteration number
    params.epsilon_1 = sqrt(3); % angle threshold sqrt(3)
    params.epsilon_2 = 10^(-4); % difference threshold 10^(-4)
    params.epsilon_3 = 10^(-0);  % Initial stopping criterion on fixed-rank 1
    params.tol = 1e-6; % final stopping criterion   % Sugg: 1e-6
    params.epsilon_4 = 0.5 * params.epsilon_1; % parameter used in increasing rank 0.5 * params.epsilon_1
    params.tau_epsilon = 0.1; % parameter used in decreasing epsilon_3 
    params.tau_r = 0.1; % parameter used in decreasing numerical rank threshold
    params.C_R = 0.1;
    
    
    fns = {};
    [X, F, G, time, T] = driver_wlr(A, Q, fns, params);
    for i = 1 : size(X, 2)
        x = X{i};
        R{i} = x.u * x.d * x.v';
        switch size(Q, 2)
        	case n
            	temp =  trace(A'* Q * A);
         	case m
            	temp = 0;
              	for j = 1 : n
                	Qi = Q(:, :, j);
                	temp = temp + A(:,j)' * Qi * A(:, j);
                end
            case m*n
            	Av = reshape(A,[],1);
             	temp = Av' * Q * Av;
        end
        err(i) = F(i) / temp;
    end
    Gend = G(end);
    
    R_Err = sqrt(err(end));
    fend = F(end); 
    Err = norm(A - R{end}, 'fro');
    diag(x.d)
end